#!/usr/bin/python
# -*- coding:utf-8 -*-

"""test module"""

from dom import *
import scorecard
import makelogo

def newInstance():
     return LiveScore_Top()

class LiveScore_Top ( scorecard.ScoreCard ):
     def __init__( self ):
          scorecard.ScoreCard.__init__( self )
          self.sid = None
          return
     
     def getName( self ):
          return "World Soccer (livescore.com)"
     
     def getVersion( self ):
          return "1.0"
     
     def getIcon( self, team ):
          return ""
     
     def getSportsCategory( self ):
          return "soccer"
     
     def getCountry( self ):
          return "World"

     def getEncoding( self ):
          return 'latin1'
     
     def getURL( self ):
          import os, tempfile, re
          if self.sid == None:
               fn_temp = tempfile.mktemp()
               os.system( "/usr/bin/curl http://www.livescore.com/ -o %s -s" % fn_temp )
               sid = None
               for line in open( fn_temp ).readlines():
                    m = re.search( 'name="sid" value="([^\"]+)"', line )
                    if m:
                         sid = m.group( 1 )
                         pass
                    pass
               if sid == None: raise Exception( "cannot get session id" )
               self.sid = sid
               pass
          return "http://www.livescore.com/default.dll?page=home&sid=%s" % self.sid
     
     def interpreteDocument( self, document ):
          import sys, os, re
          elem = document.get_element_at_path( "/html/body/table/tr/td/table/tr/td,2/table/tr" )
          if elem == None: return
          self.gameset = []
          matches = None
          while elem != None:
               probe_elem = elem.get_element_at_path( 'td' )
               if probe_elem:
                    if probe_elem.has_attribute( 'class' ) and probe_elem.get_attribute( 'class' ) == 'title':
                         title = re.sub( '<>-\\s*', ' / ', probe_elem.get_text( '<>' ) )
                         if matches != None: self.gameset.append( matches )
                         matches = { 'title': title, 'games': [] }
                         pass
                    pass
               text = []
               for td in elem.get_children():
                    if isinstance( td, Element ) and td.get_tagname() == 'td':
                         text.append( td.get_text( ' ' ) )
                         pass
                    pass
               if len( text ) > 3:
                    teams = ( text[ -3 ], text[ -1 ] )
                    score = re.split( '\\s*\-\\s*', text[ -2 ] )
                    state = ""
                    for i in range( 0, len( text ) - 3 ):
                         state += text[ i ]
                         pass
                    if matches != None:
                         matches[ 'games' ].append( ( teams[ 0 ], teams[ 1 ], score[ 0 ], score[ 1 ], state ) )
                         pass
                    pass
               try:
                    elem = elem.next_sibling( 'tr' )
               except:
                    break
               pass
          if matches != None:
               self.gameset.append( matches )
               pass
          return
     
     def getStartKeyword( self ):
          return None
     
     def getEndKeyword( self ):
          return None
     
     def getLanguage( self ):
          return "en"
     
     def toHTML( self ):
          html = self.html_header()
          for games in self.gameset:
               html += '<span class="category">%s</span><br/>' % games[ 'title' ]
               html += '<table>'
               for game in games[ 'games' ]:
                    html += '<tr><td class="team">%s</td><td class="score">%s - %s</td><td class="team">%s</td><td class="status">%s</td></tr>' \
                            % ( game[ 0 ], game[ 2 ], game[ 3 ], game[ 1 ], game[ 4 ] )
                    pass
               html += '</table>'
               pass
          html += "</html>"
          return html
     pass

